# freshmeat.tcl v1.0 by domsen <domsen@domsen.org> (c)2oo3
#
# comments? bugs? ideas? requests? money? beer? 
# plz mail me or visit my homepage @ www.domsen.org
# also check out www.uid-zero.de
#
# this script can post the latest x releases from freshmeat.net to the user and
# also searchs every x minutes for new releases. if there is a new one, it will
# be posted to certain channels. also the freshmeat search function can be used
# to find the homepages of certain projects.
#
# v1.0. - first public version
#
# freshmeattrigger - the trigger the bot respons to (public and message)
# freshmeatlimit -the maximum number of news the bot posts (on cmd)
# freshmeatnewspost  - 1 for newsposting, 0 for none
# freshmeatchans  - the chans the script is active in, "" for all
# freshmeatnewspostlimit - the maximum  news the bot posts (newsposting)
# freshmeatdehub  - 1 enables the hub function, 0 disables it
# freshmeatleafs  - the bots the leaf tcl is running on
# freshmeatsearchtrigger - the command to use for the project search
#
####### config ######################

set freshmeattrigger ".freshmeat"
set freshmeatsearchtrigger ".fms"
set freshmeatchans ""
set freshmeatlimit "5"
set freshmeatnewspostlimit "3"
set freshmeatnewspost "1"
set isfreshmeathub "0"
set freshmeatleafs ""

####### ende der config #############

bind msg - $freshmeattrigger msg_freshmeat
bind pub - $freshmeattrigger pub_freshmeat
bind msg - $freshmeatsearchtrigger msg_freshmeatsearch
bind pub - $freshmeatsearchtrigger pub_freshmeatsearch
bind time - "?0 * * * *" freshmeatcheck

proc sendfreshmeatnews { arg } {
global freshmeatleafs
foreach bot [bots] {
if {([lsearch -exact [string tolower $freshmeatleafs] [string tolower $bot]] != -1)} {
putbot $bot "freshmeat: $arg"
}}}

proc shrink { calc number string start bl} { return [expr [string first "$string" $bl $start] $calc $number] }


proc freshmeatsearch { target limit arg } {
if {$arg == ""} { return 0}
putlog "freshmeat: search by $target for ($arg)"
regsub " " $arg "%20" arg
if {[catch {set sock [socket freshmeat.net 80] } sockerror]} {
putlog "error: $sockerror"
return 0 } else {
puts $sock "GET /search/?q=$arg&section=projects HTTP/1.1"
puts $sock "User-Agent: Mozilla/5.0 (X11; U; Linux i686; en-US; rv:0.9.9)"
puts $sock "Host: freshmeat.net"
puts $sock "Connection: close"
puts $sock ""
flush $sock
set counter 0
while {[eof $sock] != 1} {
set bl [gets $sock]
if {[string first "No matches" $bl] != -1 } {putserv "privmsg $target :no matches found";return 0 }
if {[string first "Location: http://freshmeat.net/projects/" $bl] != -1 } {
set newsline $arg
set link "www.freshmeat.net/[string range $bl 30 [string last "/" $bl]]"
putserv "privmsg $target :$newsline <$link>"
}

if {[string first "href=\"/projects/" $bl] != -1} {
set link "www.freshmeat.net[string range $bl [shrink + 8 " href=\"" 0 $bl] [shrink - 1 "/\">" 0 $bl]]"
set newsline [string range $bl [shrink + 3 "<b>" 0 $bl] [shrink - 1 "</b>" 0 $bl]]
regsub -all "<b style=\"background: #FFFF00\">" $newsline "" newsline
putserv "privmsg $target :$newsline <$link>"
incr counter
}
if {$counter == $limit} {close $sock; return 0}
}}}





proc freshmeatnews { target limit } {
if {[catch {set sock [socket freshmeat.net 80] } sockerror]} {
putlog "error: $sockerror"
return 0 } else {
puts $sock "GET / HTTP/1.1"
puts $sock "User-Agent: Mozilla/4.0 (compatible; MSIE 6.0; Windows NT 5.0)"
puts $sock "Host: freshmeat.net"
puts $sock "Connection: close"
puts $sock ""
flush $sock
set counter 0
while {[eof $sock] != 1} {
set bl [gets $sock]
if {[string first "Tired of seeing a" $bl] != -1} { return 0 }
if {[string first "/releases/" $bl] != -1} {
set link "www.freshmeat.net/[string range $bl [shrink + 8 " href=\"" 0 $bl] [shrink - 1 "/\">" 0 $bl]]"
set newsline [string range $bl [shrink + 9 "#000000\">" 0 $bl] [shrink - 1 "</font>" 0 $bl]]
putserv "privmsg $target :[incr counter] $newsline <$link>"
}
if {$counter == $limit} {close $sock; return 0}
}}}


proc freshmeatcheck {nick uhost hand chan arg} {
global freshmeatchans freshmeatnewspost isfreshmeathub freshmeatnewspostlimit
set counter 0
if {$freshmeatnewspost == 1 } {
putlog "freshmeat: suche nach neuer newsline"
set freshmeatlastnews "none"
if {[file exists freshmeat.hdl]} {
set temp [open "freshmeat.hdl" r]
set freshmeatlastnews "[gets $temp]"
if {$freshmeatlastnews == ""} { set freshmeatlastnews "none" }
close $temp
}
set temp [open "freshmeat.hdl" w+]
if {[catch {set sock [socket freshmeat.net 80] } sockerror]} {
putlog "error: $sockerror"
return 0 } else {
puts $sock "GET / HTTP/1.1"
puts $sock "User-Agent: Mozilla/4.0 (compatible; MSIE 6.0; Windows NT 5.0)"
puts $sock "Host: freshmeat.net"
puts $sock "Connection: close"
puts $sock ""
flush $sock
set checker 0
while {[eof $sock] != 1 && $checker == 0} {
set bl [gets $sock]
if {[string first "Tired of seeing a" $bl] != -1} { set checker 1 }
if {[string first "/releases/" $bl] != -1} {
set link "www.freshmeat.net/[string range $bl [shrink + 8 " href=\"" 0 $bl] [shrink - 1 "/\">" 0 $bl]]"
set newsline [string range $bl [shrink + 9 "#000000\">" 0 $bl] [shrink - 1 "</font>" 0 $bl]]
puts $temp "$newsline <$link>"
}}}
close $sock ; close $temp
if {$freshmeatlastnews == "none" } { putlog "freshmeat: headlinefile created" ; return 0 }
set temp [open "freshmeat.hdl" r]
while { [eof $temp] != 1 } {
set freshmeatneunews [gets $temp]
if {($freshmeatlastnews == $freshmeatneunews) || ($counter == $freshmeatnewspostlimit)} { close $temp;return 0 }
incr counter
foreach chan [channels] {
if {$freshmeatchans == "" } { putserv "privmsg $chan :(new freshmeat release) $freshmeatneunews" }
if {$freshmeatchans != "" } {
if {([lsearch -exact [string tolower $freshmeatchans] [string tolower $chan]] != -1) || ($freshmeatchans == "")} {putserv "privmsg $chan :(new freshmeat release) $freshmeatneunews"}
}
if { $isfreshmeathub == "1" } { sendfreshmeatnews $freshmeatneunews }
}}}}


proc msg_freshmeat { nick uhost hand arg } { global freshmeatlimit ; freshmeatnews $nick $freshmeatlimit }
proc pub_freshmeat { nick uhost hand chan arg } { global freshmeatchans freshmeatlimit ; if {([lsearch -exact [string tolower $freshmeatchans] [string tolower $chan]] != -1) || ($freshmeatchans == "")} { freshmeatnews $nick $freshmeatlimit }}
proc msg_freshmeatsearch { nick uhost hand arg } { global freshmeatlimit ; freshmeatsearch $nick $freshmeatlimit $arg}
proc pub_freshmeatsearch { nick uhost hand chan arg } { global freshmeatchans freshmeatlimit ; if {([lsearch -exact [string tolower $freshmeatchans] [string tolower $chan]] != -1) || ($freshmeatchans == "")} { freshmeatsearch $nick $freshmeatlimit $arg }}

putlog "*** freshmeat.tcl v1.0 by domsen <domsen@domsen.org> succesfully loaded"

#[EOF]
